commit 62d505150ed50a63bbb69e4eaa68e3936ff5bbcb
Author: Simon Schulz <sschulz@cit-ec.uni-bielefeld.de>
Date:   Tue Apr 14 16:56:07 2015 +0200

    testing one cmake for all

diff --git a/client/CMakeLists.txt b/client/CMakeLists.txt
new file mode 100644
index 0000000..899c28c
--- /dev/null
+++ b/client/CMakeLists.txt
@@ -0,0 +1,27 @@
+CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
+
+PROJECT("hlrc_client")
+
+SET(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)
+
+#options
+OPTION(BUILD_CPP "Decide whether to build the CPP bindings." ON)
+OPTION(BUILD_JAVA "Decide whether to build the Java bindings." ON)
+OPTION(BUILD_PYTHON "Decide whether to build the Python bindings." ON)
+
+
+
+IF(BUILD_CPP)
+    ADD_SUBDIRECTORY(cpp)
+ENDIF()
+
+IF(BUILD_JAVA)
+    ADD_SUBDIRECTORY(java)
+ENDIF()
+
+IF(BUILD_PYTHON)
+    ADD_SUBDIRECTORY(python)
+ENDIF()
+
+
+
diff --git a/client/java/CMakeLists.txt b/client/java/CMakeLists.txt
new file mode 100644
index 0000000..56f49cd
--- /dev/null
+++ b/client/java/CMakeLists.txt
@@ -0,0 +1,19 @@
+cmake_minimum_required(VERSION 2.8)
+
+SET(JAR_FILE "${CMAKE_CURRENT_BINARY_DIR}/hlrc_client_java-0.1.jar" )
+
+FIND_PROGRAM(MVN_EXECUTABLE mvn)
+IF(MVN_EXECUTABLE)
+    ADD_CUSTOM_COMMAND(OUTPUT  ${JAR_FILE}
+                       COMMAND ${MVN_EXECUTABLE} install appassembler::assemble
+                       WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
+                       COMMENT "Creating jar files")
+
+    ADD_CUSTOM_TARGET(java ALL DEPENDS ${JAR_FILE})
+
+    INSTALL(FILES ${JAR_FILE} DESTINATION share/java)
+
+ELSE()
+    MESSAGE(STATUS "mvn not found. java bindings will not be created")
+ENDIF()
+
diff --git a/client/java/pom.xml b/client/java/pom.xml
index a1d4749..4f07161 100644
--- a/client/java/pom.xml
+++ b/client/java/pom.xml
@@ -3,9 +3,9 @@
     <modelVersion>4.0.0</modelVersion>
     <groupId>de.citec.csra</groupId>
     <artifactId>hlrc-client</artifactId>
-    <version>1.0.0-SNAPSHOT</version>
+    <version>0.1-SNAPSHOT</version>
     <packaging>jar</packaging>
-    <name>High Level Command Client</name>
+    <name>High Level Robot Control java client</name>
     <url>http://maven.apache.org</url>
     <build>
         <plugins>
diff --git a/client/python/CMakeLists.txt b/client/python/CMakeLists.txt
new file mode 100644
index 0000000..357910a
--- /dev/null
+++ b/client/python/CMakeLists.txt
@@ -0,0 +1,3 @@
+cmake_minimum_required(VERSION 2.8)
+
+install(CODE "execute_process(COMMAND python setup.py install -f --prefix=${CMAKE_INSTALL_PREFIX} WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})")
diff --git a/client/python/dist/hlrc_client-1.2.0-py2.7.egg b/client/python/dist/hlrc_client-1.2.0-py2.7.egg
index 514d37b..21018bf 100644
Binary files a/client/python/dist/hlrc_client-1.2.0-py2.7.egg and b/client/python/dist/hlrc_client-1.2.0-py2.7.egg differ
diff --git a/client/python/hlrc_client.egg-info/PKG-INFO b/client/python/hlrc_client.egg-info/PKG-INFO
index b863850..e6395dd 100644
--- a/client/python/hlrc_client.egg-info/PKG-INFO
+++ b/client/python/hlrc_client.egg-info/PKG-INFO
@@ -1,6 +1,6 @@
 Metadata-Version: 1.1
 Name: hlrc-client
-Version: 1.2.0
+Version: 0.1
 Summary: [h]igh [l]evel [r]obot [c]ontrol client project
 Home-page: http://opensource.cit-ec.uni-bielefeld.de/hlrc
 Author: Simon Schulz
diff --git a/client/python/hlrc_client.egg-info/SOURCES.txt b/client/python/hlrc_client.egg-info/SOURCES.txt
index 9572210..7101826 100644
--- a/client/python/hlrc_client.egg-info/SOURCES.txt
+++ b/client/python/hlrc_client.egg-info/SOURCES.txt
@@ -4,6 +4,7 @@ README.rst
 setup.cfg
 setup.py
 hlrc_client/Middleware.py
+hlrc_client/MiddlewareROS.py
 hlrc_client/MiddlewareRSB.py
 hlrc_client/RobotAnimation.py
 hlrc_client/RobotController.py
diff --git a/client/python/hlrc_client.egg-info/requires.txt b/client/python/hlrc_client.egg-info/requires.txt
index 5026bf1..f79d3b2 100644
--- a/client/python/hlrc_client.egg-info/requires.txt
+++ b/client/python/hlrc_client.egg-info/requires.txt
@@ -1,4 +1,4 @@
-peppercorn
+
 
 [test]
 coverage
diff --git a/client/python/setup.py b/client/python/setup.py
index bcb63d2..f88cd9a 100644
--- a/client/python/setup.py
+++ b/client/python/setup.py
@@ -23,7 +23,7 @@ setup(
     # Versions should comply with PEP440.  For a discussion on single-sourcing
     # the version across setup.py and the project code, see
     # https://packaging.python.org/en/latest/single_source_version.html
-    version='1.2.0',
+    version='0.1',
 
     description='[h]igh [l]evel [r]obot [c]ontrol client project',
     long_description=long_description,
@@ -75,7 +75,7 @@ setup(
     # your project is installed. For an analysis of "install_requires" vs pip's
     # requirements files see:
     # https://packaging.python.org/en/latest/requirements.html
-    install_requires=['peppercorn'],
+    install_requires=[],
 
     # List additional groups of dependencies here (e.g. development
     # dependencies). You can install these using the following syntax,