commit ea068cf1895f60473f109326def6bff27dd7e4e3
Author: sschulz <sschulz@techfak.uni-bielefeld.de>
Date:   Mon Feb 22 11:04:00 2016 +0100

    cleaning up and naming convention

diff --git a/src/server/joint_interface.cpp b/src/server/joint_interface.cpp
index 328295b..f13348b 100644
--- a/src/server/joint_interface.cpp
+++ b/src/server/joint_interface.cpp
@@ -34,8 +34,8 @@ using humotion::server::JointInterface;
 //! constructor
 JointInterface::JointInterface() {
     framerate = 50.0;
-    mouth_enabled = false;
-    gaze_enabled  = false;
+    mouth_enabled_ = false;
+    gaze_enabled_  = false;
 }
 
 //! destructor
@@ -75,21 +75,21 @@ void JointInterface::store_incoming_position(int joint_id, float position, Times
     // lock the tsd_list for this access. by doing this we assure
     // that no other thread accessing this element can diturb the
     // following atomic instructions:
-    mutex::scoped_lock sl(joint_ts_position_map_access_mutex);
+    mutex::scoped_lock sl(joint_ts_position_map_access_mutex_);
 
     // printf("> humotion: incoming joint position for joint id 0x%02X "
     // "= %4.2f (ts=%.2f)\n",joint_id,position,timestamp.to_seconds());
-    joint_ts_position_map[joint_id].insert(timestamp, position);
+    joint_ts_position_map_[joint_id].insert(timestamp, position);
 
-    incoming_position_count++;
+    incoming_position_count_++;
 }
 
 //! return incoming position data count & clear this counter
 //! this can be used as a keep alive status check
 //! \return number of incoming joint positions since the last call
 unsigned int JointInterface::get_and_clear_incoming_position_count() {
-    unsigned int i = incoming_position_count;
-    incoming_position_count = 0;
+    unsigned int i = incoming_position_count_;
+    incoming_position_count_ = 0;
     return i;
 }
 
@@ -101,11 +101,11 @@ void JointInterface::store_incoming_velocity(int joint_id, float velocity, Times
     // lock the tsd_list for this access. by doing this we assure
     // that no other thread accessing this element can disturb the
     // following atomic instructions:
-    mutex::scoped_lock scoped_lock(joint_ts_speed_map_access_mutex);
+    mutex::scoped_lock scoped_lock(joint_ts_speed_map_access_mutex_);
 
     // printf("> humotion: incoming joint velocity for joint id 0x%02X = %4.2f "
     // "(ts=%.2f)\n",joint_id,velocity,timestamp.to_seconds());
-    joint_ts_speed_map[joint_id].insert(timestamp, velocity);
+    joint_ts_speed_map_[joint_id].insert(timestamp, velocity);
 }
 
 //! return the timestamped float for the given joints position
@@ -113,12 +113,12 @@ humotion::TimestampedList JointInterface::get_ts_position(int joint_id) {
     // lock the tsd_list for this access. by doing this we assure
     // that no other thread accessing this element can disturb the
     // following atomic instructions
-    mutex::scoped_lock sl(joint_ts_position_map_access_mutex);
+    mutex::scoped_lock sl(joint_ts_position_map_access_mutex_);
 
     // search map
-    joint_tsl_map_t::iterator it = joint_ts_position_map.find(joint_id);
+    joint_tsl_map_t::iterator it = joint_ts_position_map_.find(joint_id);
 
-    if (it == joint_ts_position_map.end()) {
+    if (it == joint_ts_position_map_.end()) {
         printf("> humotion: no ts_position for joint id 0x%02X found\n", joint_id);
         return TimestampedList();
     }
@@ -132,12 +132,12 @@ humotion::TimestampedList JointInterface::get_ts_speed(int joint_id) {
     // lock the tsd_list for this access. by doing this we assure
     // that no other thread accessing this element can diturb the
     // following atomic instructions
-    mutex::scoped_lock sl(joint_ts_speed_map_access_mutex);
+    mutex::scoped_lock sl(joint_ts_speed_map_access_mutex_);
 
     // search map
-    joint_tsl_map_t::iterator it = joint_ts_speed_map.find(joint_id);
+    joint_tsl_map_t::iterator it = joint_ts_speed_map_.find(joint_id);
 
-    if (it == joint_ts_speed_map.end()) {
+    if (it == joint_ts_speed_map_.end()) {
         printf("> humotion: no ts_speed for joint id 0x%02X found\n", joint_id);
         return humotion::TimestampedList();
     }
@@ -154,7 +154,7 @@ void JointInterface::set_framerate(float f) {
 //! enable all mouth joints
 void JointInterface::enable_mouth_joints() {
     // already enabled? skip this
-    if (mouth_enabled) {
+    if (mouth_enabled_) {
         return;
     }
 
@@ -165,14 +165,14 @@ void JointInterface::enable_mouth_joints() {
     enable_joint(ID_LIP_CENTER_LOWER);
     enable_joint(ID_LIP_RIGHT_UPPER);
     enable_joint(ID_LIP_RIGHT_LOWER);
-    mouth_enabled = true;
+    mouth_enabled_ = true;
 }
 
 
 //! disable all mouth joints
 void JointInterface::disable_mouth_joints() {
     // already disabled? skip this
-    if (!mouth_enabled) {
+    if (!mouth_enabled_) {
         return;
     }
 
@@ -183,13 +183,13 @@ void JointInterface::disable_mouth_joints() {
     disable_joint(ID_LIP_CENTER_LOWER);
     disable_joint(ID_LIP_RIGHT_UPPER);
     disable_joint(ID_LIP_RIGHT_LOWER);
-    mouth_enabled = false;
+    mouth_enabled_ = false;
 }
 
 //! enable all gaze joints
 void JointInterface::enable_gaze_joints() {
     // already enabled? skip this
-    if (gaze_enabled) {
+    if (gaze_enabled_) {
         return;
     }
 
@@ -210,13 +210,13 @@ void JointInterface::enable_gaze_joints() {
     enable_joint(ID_NECK_TILT);
     enable_joint(ID_NECK_ROLL);
 
-    gaze_enabled = true;
+    gaze_enabled_ = true;
 }
 
 //! disable all gaze joints
 void JointInterface::disable_gaze_joints() {
     // already disabled? skip this
-    if (!gaze_enabled) {
+    if (!gaze_enabled_) {
         return;
     }
 
@@ -237,7 +237,7 @@ void JointInterface::disable_gaze_joints() {
     disable_joint(ID_NECK_TILT);
     disable_joint(ID_NECK_ROLL);
 
-    gaze_enabled = false;
+    gaze_enabled_ = false;
 }
 
 //! fetch maximum allowed joint position
@@ -257,7 +257,7 @@ float JointInterface::get_joint_min(int joint_id) {
 //! check if joint position map is empty
 //! \return true if empty
 bool JointInterface::get_joint_position_map_empty() {
-    return (joint_ts_position_map.empty());
+    return (joint_ts_position_map_.empty());
 }
 
 //! call the virtual store function with given position and velocities